import {
  select,
	json,
  csv,
  geoPath,
  geoAlbersUsa,
  scaleThreshold,
  scaleOrdinal,
  schemeOrRd,
  filter
} from 'd3';

import {
feature
} from 'topojson';

const svg = select('svg');
const projection = geoAlbersUsa();
const pathGenerator = geoPath().projection(projection);
const g = svg.append('g');

Promise.all([
	csv('https://raw.githubusercontent.com/andycho97/COVID_Visualization_Project/main/D3Map.csv'),
  json('https://vizhub.com/elaine-xiao/datasets/states-10m.json')
]).then(([csvData, topoJASONdata]) => {
  
  const regionname = {};
  const positive_test = {};
  const positivenumlog = {};
  const colorsample = {};
  
  csvData.forEach(d => {
    
    regionname[d.state_name] = d.seven_day_average_death_toll;
    positive_test[d.state_name] = d.seven_day_average_Positive;
    positivenumlog[d.state_name] = Math.log((+d.seven_day_average_Positive)+1);
  
  });

  const states = feature(topoJASONdata, topoJASONdata.objects.states); 
  const colorScale = scaleOrdinal(); 
  const colorValue = d => positive_test[d.properties.name];
  // const colorValue = d => d.properties.positive_test / 10000;
  
  // console.log(colorValue['Alaska']);
  
  const render=()=>{
  
    colorScale
    .domain(features.map(positive_test))
    .domain(colorScale.domain().sort().reverse())
    .range(scaleOrdinal[colorScale.domain().length]);

};
  
  // colorScale.domain(colorScale.domain().filter(function (el) {
  // return el != null;}).sort()).range(d3.schemeReds[9]);
  
  
  //colorScale.domain(states.features.map(colorValue))
  	//.domain([0,1,2,3,4,5,6,7,8])
  // console.log(colorScale.domain());
  // console.log(colorScale.range());
  // console.log(colorScale.domain());
  // console.log(positivenumlog);
  
  g.selectAll('path')
  	.data(states.features)
    .enter()
    	.append('path')
  			.attr('class', 'state')
  			.attr('d', pathGenerator)
  			.attr('fill', 'red')			
  //.attr('fill', d => colorScale(colorValue(d)))
  		.append('title')
  			.text("State: ")
  		.append('title1')
  			.text(d => d.properties.name)
    	.append('title2')
  			.text("\n7 Day Death Avg: ")
  		.append('title3')
  			.text(d => regionname[d.properties.name])
     	.append('title4')
  			.text("\n7 Day Positive Test Avg: ")
  		.append('title5')
  			.text(d => positive_test[d.properties.name]) ; 

  
});